#! /usr/bin/env python34

# Program Name "massagemodUTF8.py"

# This module contains the function massage()
# that post-processes TRYSYS output files.


# 
# Python Programmer:  Emeritus Prof. William SCHULZ, NaU, Trantor IV

# Original version date:  11/27/13
# Latest mods by Wiliam Schulz: 7/11/14
# Latest mods by Robert Dean:  1/15/16 

# Call THIS version of massagemod when Unicode codes => 256 are used in the cmdfile.
# E.g., for Cyrillic, Chinese, Korean, Japanese, Arabic, etc.
 

import os, sys, string, math, re, shutil, codecs

def massage(arg1):

	if arg1 == "MONOUT":
		outfilestring = "MONOUT"
	else:
		outarray = arg1.split(".")
#		outfilestring = outarray[0]+"M."+outarray[1]
		outfilestring = outarray[0]+".outM"	
		
#	infile = open(arg1, "r")                                         #Original Schulz open statements
#	outfile = open(outfilestring, "w")		                 #Use for accented Latin in varnames
		
		
	infile = open(arg1,encoding="utf-8",mode = "r")             # Open statements for UTF-8 encoded input &
	outfile = open(outfilestring,encoding="utf-8",mode = "w")   # output files--handles Unicodes > 255.
                                                                    # Solution provided by Brian.Costlow@gmail.com 
	
       

	testchar = '\u000C'
#	#print(testchar)

	for line in infile:                                                  #suckout lines for modification
		if line[0]== "1":
			line = line[1:]
			line = testchar+line
		line = line.replace("PAGE","Page")                               #changes PAGE to Page
		line = line.replace(" 0.","  .")                                 #removes 0 in decimals
		line = line.replace(" -0.", "  -.")                              #removes 0 in negative decimals
		line = line.replace("_", " ");                                   #substitutes blanks for underscores		
		
	#	line = line.replace("*COMMENT", "*Analysis Notes");              #changes COMMENT to 
	#	line = line.replace("*comment", "*Analysis Notes");              #changes comment to 
	#	line = line.replace("*END", "*End Run");		                 #changes END to End Run
	#	line = line.replace("*end", "*End Run");		                 #changes end to End Run
		
				
		igcomment=re.compile(re.escape('*comment'),re.IGNORECASE)
		line=igcomment.sub('*Analysis Notes',line)
		
		igend=re.compile(re.escape('*end'),re.IGNORECASE)
		line=igend.sub('*End Run',line)
		
      
#       Template lines for replacing the English words with foreign language phrases.

#		line = line.replace("CORRELATION MATRIX", ""); 
#		line = line.replace("DATA IDENTIFICATION", " "); 
#		line = line.replace("Communality Estimates by", " ");
#		line = line.replace("Communality Estimates By", " ");
#		line = line.replace("COMMUNALITY  ESTIMATES  BY", " ");
#		line = line.replace("Largest Correlations for Each Variable", " ");
#		line = line.replace("Elapsed time is", " "); 
#		line = line.replace("seconds", " "); 
#		line = line.replace("The   ", " "); 
		
		
		outfile.write(line)
		
	infile.close()
	outfile.close()
	



