#! /usr/bin/env python3

#Program Name:  TRYRUN.py

#Purpose: Front end for running  TRYSYS data analyses

#Version 07.01.16

#Programmer: Dr. William C. Schulz, NaU, NovaTrantor IV

#Latest modifications by Robert Dean:  1/12/16; 1/15/21

import os, sys, string, math, re, shutil
from subprocess import call

def main(args): 
   """Primary program for running TRYSYS analyses"""

   print('\n  You are using the  T R Y R U N  console app to determine which')
   print('     type of TRYSYS analysis you wish to select and then run.' )
    
   print('\n  Do you need to process raw data & generate a correlation matrix?' )
   print('    If Yes, type  D  ; otherwise type  T (case insensitive):')
   
   choose = 'fuck'
   while choose not in {'D','d','T','t'}:
      choose = input('\n  Enter either a D (calls TRYDAP) or a T (calls TRYTAKE): ')      
      if choose in {'D','d'}:
         print('\n  Calling TRYDAP')
#         call('python TRYDAP-kk.py')
         call('python c:/trysys/TRYDAP.py') #  Ditto below . . .
		 
      elif choose in {'T','t'}:
         print('\n  Calling TRYTAKE')

#        call('python TRYTAKE.py')
         call('python c:/trysys/TRYTAKE.py')	  # Provides full path to the trytake- script. 	 

      else:
         print('\n  Enter only  D  or  T . Remember, D calls TRYDAP & T calls TRYTAKE.')
         print('\n  You have another chance to get it right.')
  
   return
  
if __name__ == "__main__":
  main(sys.argv)
  
end = input("\n   Press  Return  to close TRYRUN.")

