#! /usr/bin/env python3

# Program Name "massagemodascii.py"

# This module contains the function massage()
# that post-processes TRYSYS output files.

# (The stand-alone test program that handles this is massage.py .)
# 
#Programmer:  Dr. William C. Schulz, NaU  NovaTrantor IV

# Original version date:  11.27.13

# Last mods by William Schulz:  7/27/15

# Latest minor mods by Robert Dean:  12/26/17;  12/24/18;  4/26/20 

# Call THIS version of massagemod when  o n l y  ascii (unaccented & accented Latin)
# characters occur in command files. This will be most of the time.
 
# (New lines ~40-41 enable the alternative massagemodutf8 module to handle Unicode
#  characters in input and output files.)


import os, sys, string, math, re, shutil, codecs

def massage(arg1):

	if arg1 == "MONOUT":
		outfilestring = "MONOUT"                            #Deleted the M from this filename   RBD 1/13/16
	else:
		outarray = arg1.split(".")
#		outfilestring = outarray[0]+"M."+outarray[1]
		outfilestring = outarray[0]+".outM"		
		
	infile = open(arg1, "r")                                    # Original Schulz open statements
	outfile = open(outfilestring, "w")		            # Use for accented Latin in varnames
		
		
#	infile = open(arg1,encoding="utf-8",mode = "r")             # Open statements for UTF-8 encoded input &
#	outfile = open(outfilestring,encoding="utf-8",mode = "w")   # output files--handle Unicodes > 255  
                                                                    # Solution provided by Brian Costlow 
	
       

	testchar = '\u000C'
#	#print(testchar)

	for line in infile:                                         #Suck out lines for global substitution
		if line[0]== "1":
			line = line[1:]
			line = testchar+line
		line = line.replace("PAGE","Page")                      #changes PAGE to Page
		line = line.replace(" 0.","  .")                        #removes 0 in decimals
		line = line.replace(" -0.", "  -.")                     #removes 0 in negative decimals
		line = line.replace("_", " ")                           #substitutes blanks for underscores
		
#		line = line.replace("john.bauer@comcast.net","    (1985-2015)")	 John Bauer 1943-2015  			
	
		
		         

		
		igcomment=re.compile(re.escape('*comment'),re.IGNORECASE)
		line=igcomment.sub('*Analysis Notes',line)
		
		igend=re.compile(re.escape('*end'),re.IGNORECASE)
		line=igend.sub('*End Run',line)
		
      
   
#		line = line.replace("CORRELATION MATRIX", ""); 
#		line = line.replace("DATA IDENTIFICATION", " "); 
#		line = line.replace("Communality Estimates By", " ");

#		line = line.replace("Largest Correlations for Each Variable", " ");
#		line = line.replace("Elapsed time is", " "); 
#		line = line.replace("seconds", " "); 
#		line = line.replace("The   ", " ");     #??

		
		outfile.write(line)
		
	infile.close()
	outfile.close()
	



