﻿#! /usr/bin/env python3

# Program Name "massagemodFR.py"

# This module contains the function massage()
# that post-processes TRYSYS output files.

# (The stand-alone test program that handles this is massage.py .)

# This massagemod replaces selected English output text by text in FRENCH.
 
# Python Programmer: Dr. William C. Schulz, NaU  NovaTrantor IV

# Original version date:  11.27.13

# Latest minor mods by Robert Dean:  4/26/16, 1/14/18;  4/29/20  



import os, sys, string, math, re, shutil, codecs

def massage(arg1):

	if arg1 == "MONOUT":
		outfilestring = "MONOUTM"
	else:
		outarray = arg1.split(".")
#		outfilestring = outarray[0]+"M."+outarray[1]
		outfilestring = outarray[0]+".outM"	
		
	infile = open(arg1, "r")                                   #Original open statements
	outfile = open(outfilestring, "w")		           #Use for accented latin in varnames
		
		
	
        

	testchar = '\u000C'
#	#print(testchar)

	for line in infile:                                                      #Suckout lines for modification
		if line[0]== "1":
			line = line[1:]
			line = testchar+line
		line = line.replace("PAGE","Page")                               #changes PAGE to Page
		line = line.replace(" 0.","  .")                                 #removes 0 in decimals
		line = line.replace(" -0.", "  -.")                              #removes 0 in negative decimals
		line = line.replace("_", " ");                                   #substitutes blanks for underscores
		
#		line = line.replace("john.bauer@comcast.net","    (1985-2015)")  #John Bauer 1943-2015 RIP
		
		
		line = line.replace("*COMMENT", "*Les notes sur l'analyse");     #changes COMMENT to Les notes...
		line = line.replace("*comment", "*Les notes sur l'analyse");     #changes comment to Les notes...   

		line = line.replace("CORRELATION MATRIX", "Matrice de corrélations"); 
		line = line.replace("DATA IDENTIFICATION", "Identification de données: "); 
		line = line.replace("Communality Estimates by", "Des estimations de la 'communalité' par ");
#		line = line.replace("Communality Estimates By", "Des estimations de la 'communalité' par ");
#		line = line.replace("COMMUNALITY  ESTIMATES  BY", "Des estimations de la 'communalité' par ");
		line = line.replace("Largest Correlations for Each Variable", "plus grands corrélations pour chaque variable");
		line = line.replace("*END", " Fin de l'analyse");
		line = line.replace("*end", " Fin de l'analyse");
		line = line.replace("Elapsed CPU time is", "Le temps écoulé est"); 
		line = line.replace("seconds", "secondes"); 
#		line = line.replace("The ", "Les "); 
		outfile.write(line)
		
	infile.close()
	outfile.close()
	



